package com.inca.npbusi.saset.bms_sa_rec;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.npbusi.dataimport.ImpHelper;
import com.inca.npbusi.saset.bms_sa_rec.Bms_sa_rec_mde;
import com.inca.npbusi.saset.bms_sa_rec.notes.Pub_notes_hov;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.UsemmHelper;
import com.inca.pubsrv.hov.pub_custom_to_saler_hov.Pub_custom_to_saler_hov;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.math.BigDecimal;
import javax.swing.JPanel;

public class Bms_sa_rec_master extends CMasterModel {
  public Bms_sa_rec_master(CFrame paramCFrame, CMdeModel paramCMdeModel) {
    super(paramCFrame, "销售收款总单", paramCMdeModel);
  }
  
  public String getTablename() {
    return "bms_sa_rec_doc_v";
  }
  
  public String getSaveCommandString() {
    return null;
  }
  
  protected int on_beforeNew() {
    String str;
    if ((str = ((Bms_sa_rec_mde)this.mdemodel).getEntryid()) == null || str.equals("")) {
      errorMessage("错误", "您当前登录的角色没有指定独立单元，不能录入订单！");
      return -1;
    } 
    return super.on_beforeNew();
  }
  
  protected int on_new(int paramInt) {
    Userruninfo userruninfo = ClientUserManager.getCurrentUser();
    setItemValue(paramInt, "inputmanid", userruninfo.getUserid());
    setItemValue(paramInt, "inputmanname", userruninfo.getUsername());
    setItemValue(paramInt, "entryid", ((Bms_sa_rec_mde)this.mdemodel)
        .getEntryid());
    setItemValue(paramInt, "entryname", ((Bms_sa_rec_mde)this.mdemodel)
        .getEntryname());
    setItemValue(paramInt, "usestatus", "2");
    setItemValue(paramInt, "recmethod", "3");
    setItemValue(paramInt, "initflag", "0");
    setItemValue(paramInt, "recman", userruninfo.getUsername());
    setItemValue(paramInt, "recmanid", userruninfo.getUserid());
    setItemValue(paramInt, "credate", NpbusiDBHelper.getSysdate());
    try {
      setItemValue(paramInt, "recmanopcode", ImpHelper.getOpcode(userruninfo.getUsername()));
    } catch (Exception exception) {
      (userruninfo = null).printStackTrace();
    } 
    String str = getItemValue(paramInt, "recmethod");
    if (!"3".equals(str)) {
      getDBColumnDisplayInfo("presaleropcode").setReadonly(false);
    } else {
      getDBColumnDisplayInfo("presaleropcode").setReadonly(true);
    } 
    return super.on_new(paramInt);
  }
  
  protected int on_checkrow(int paramInt, DBTableModel paramDBTableModel) {
    String str1;
    if ((str1 = getItemValue(paramInt, "credate")) == null || str1.equals("") || 
      str1.substring(0, 10).equals("0000-00-00")) {
      errorMessage("错误", "建立日期不能为空!");
      return -1;
    } 
    try {
      String str;
      boolean bool;
      if (!(str = paramDBTableModel.getItemValue(paramInt, "usestatus")).equals("1") && 
        
        !(bool = UsemmHelper.checkBusidate(str1))) {
        warnMessage("警告", "日期" + str1 + "所在逻辑月已经结帐！");
        return -1;
      } 
    } catch (Exception exception2) {
      Exception exception1;
      (exception1 = null).printStackTrace();
      errorMessage("错误", exception1.getMessage());
      return -1;
    } 
    String str2 = getItemValue(paramInt, "recmethod");
    if ("1".equals(str2)) {
      str2 = getItemValue(paramInt, "presalerid");
      str1 = getItemValue(paramInt, "presadeptid");
      String str = getItemValue(paramInt, "total");
      if (str2 == null || str2.equals("")) {
        errorMessage("错误", "预收款业务员ID不能为空!");
        return -1;
      } 
      if (str1 == null || str1.equals("")) {
        errorMessage("错误", "预收款业务部门ID不能为空!");
        return -1;
      } 
      if ((str1 = getItemValue(paramInt, "oldprerecid")) == null || "".equals(str1)) {
        if (str == null || 
          "".equals(str) || 
          DecimalHelper.toDec(str).compareTo(
            new BigDecimal("0")) <= 0) {
          infoMessage("提示", "预收款为负数的时候,请选择勾兑原预收款单！");
          return -1;
        } 
        if (DecimalHelper.toDec(str1 = getItemValue(paramInt, "premoney"))
          .compareTo(new BigDecimal("0")) < 0) {
          infoMessage("提示", "您在进行预收款核销，细单金额不能是负数！");
          return -1;
        } 
        str2 = getItemValue(paramInt, "recexpmoney");
        if (DecimalHelper.toDec(str1).compareTo((
            new BigDecimal(str)).subtract(
              DecimalHelper.toDec(str2))) > 0) {
          infoMessage("提示", "您在进行预收款核销，细单金额不能大于收款额！");
          return -1;
        } 
      } else if (str == null || 
        "".equals(str) || 
        DecimalHelper.toDec(str).compareTo(
          new BigDecimal("0")) > 0) {
        infoMessage("提示", "您选择了原预收款单，收款额必须为负数！");
        return -1;
      } 
      if (DecimalHelper.toDec(str1 = this.mdemodel.getDetailModel().getSumdbmodel().sum("total_line").toString()).compareTo(new BigDecimal("0")) < 0) {
        infoMessage("提示", "您在进行预收款核销，细单的收款金额之和必须是正数！");
        return -1;
      } 
    } else if ("2".equals(str2)) {
      errorMessage("错误", "收款类别不允许为现收，只能为预收款或收欠款");
      return -1;
    } 
    if ((str2 = getItemValue(paramInt, "fmid")) == null || str2.equals("")) {
      setItemValue(paramInt, "fmid", "0");
      setItemValue(paramInt, "exchange", "1");
    } 
    return super.on_checkrow(paramInt, paramDBTableModel);
  }
  
  protected void on_itemvaluechange(int paramInt, String paramString1, String paramString2) {
    if (paramString1.equals("customid")) {
      String str1 = ((Bms_sa_rec_mde)this.mdemodel).getEntryid();
      String str2 = "select settletypeid from pub_company_to_definfo where companyid=" + 
        paramString2 + " and (entryid is null or entryid=" + str1 + ") order by nvl(entryid,-1) desc";
      RemotesqlHelper remotesqlHelper = new RemotesqlHelper();
      try {
        DBTableModel dBTableModel;
        str2 = (dBTableModel = remotesqlHelper.doSelect(str2, 0, 1)).getItemValue(0, "settletypeid");
        setItemValue(paramInt, "rectypeid", str2);
      } catch (Exception exception2) {
        Exception exception1;
        (exception1 = null).printStackTrace();
      } 
      String str3;
      if ((str3 = getItemValue(paramInt, "agentid")) != null || !str3.equals("")) {
        setItemValue(paramInt, "agentid", "");
        setItemValue(paramInt, "agentopcode", "");
        setItemValue(paramInt, "agentname", "");
      } 
      if ((str2 = getItemValue(paramInt, "recmethod")) != null && str2.equals("1"))
        try {
          int i = paramInt;
          String str4 = paramString2;
          str2 = str1;
          com.inca.npbusi.saset.bms_sa_rec.Bms_sa_rec_master bms_sa_rec_master = this;
          RemotesqlHelper remotesqlHelper1 = new RemotesqlHelper();
          String str5 = "select * from pub_custom_to_saler_v where customid=" + str4 + " and entryid=" + str2;
          DBTableModel dBTableModel;
          if ((dBTableModel = remotesqlHelper1.doSelect(str5, 0, 10)) == null || dBTableModel.getRowCount() < 0) {
            bms_sa_rec_master.infoMessage("提示", "没有业务员，不可录入总单！");
            bms_sa_rec_master.setItemValue(i, "presaleropcode", "");
            bms_sa_rec_master.setItemValue(i, "presalername", "");
            bms_sa_rec_master.setItemValue(i, "presadeptname", "");
          } else if (dBTableModel.getRowCount() == 1) {
            String str7 = dBTableModel.getItemValue(0, "salerdeptid");
            str2 = dBTableModel.getItemValue(0, "salerid");
            str4 = dBTableModel.getItemValue(0, "saleropcode");
            String str8 = dBTableModel.getItemValue(0, "salername"), str6 = dBTableModel.getItemValue(0, "salerdeptname");
            if (str7 == null || "".equals(str7)) {
              str6 = "select * from pub_employee_v where employeeid=" + str2;
              DBTableModel dBTableModel1;
              str7 = (dBTableModel1 = remotesqlHelper1.doSelect(str6, 0, 1)).getItemValue(0, "deptid");
              str6 = dBTableModel1.getItemValue(0, "deptname");
            } 
            bms_sa_rec_master.setItemValue(i, "presalerid", str2);
            bms_sa_rec_master.setItemValue(i, "presaleropcode", str4);
            bms_sa_rec_master.setItemValue(i, "presalername", str8);
            bms_sa_rec_master.setItemValue(i, "presadeptname", str6);
            bms_sa_rec_master.setItemValue(i, "presadeptid", str7);
          } else {
            Pub_custom_to_saler_hov pub_custom_to_saler_hov;
            (pub_custom_to_saler_hov = new Pub_custom_to_saler_hov(true)).setOtherwheres("customid = " + str4 + " and entryid=" + str2);
            DBTableModel dBTableModel1;
            if ((dBTableModel1 = pub_custom_to_saler_hov.showDialog((Frame)bms_sa_rec_master.frame, "")) == null) {
              bms_sa_rec_master.setItemValue(i, "presalerid", "");
              bms_sa_rec_master.setItemValue(i, "presaleropcode", "");
              bms_sa_rec_master.setItemValue(i, "presalername", "");
              bms_sa_rec_master.setItemValue(i, "presadeptname", "");
              bms_sa_rec_master.setItemValue(i, "presadeptid", "");
            } else {
              str4 = dBTableModel1.getItemValue(0, "salerid");
              String str9 = dBTableModel1.getItemValue(0, "saleropcode"), str8 = dBTableModel1.getItemValue(0, "salername"), str7 = dBTableModel1.getItemValue(0, "salerdeptname"), str6 = dBTableModel1.getItemValue(0, "salerdeptid");
              bms_sa_rec_master.setItemValue(i, "presalerid", str4);
              bms_sa_rec_master.setItemValue(i, "presaleropcode", str9);
              bms_sa_rec_master.setItemValue(i, "presalername", str8);
              bms_sa_rec_master.setItemValue(i, "presadeptname", str7);
              bms_sa_rec_master.setItemValue(i, "presadeptid", str6);
            } 
          } 
        } catch (Exception exception) {
          (str1 = null).printStackTrace();
        }  
    } else if (paramString1.equals("recmethod")) {
      if ("1".equals(paramString2)) {
        getDBColumnDisplayInfo("presaleropcode").setReadonly(false);
        setItemValue(paramInt, "recexptype", "");
        setItemValue(paramInt, "recexpmoney", "");
      } else if ("3".equals(paramString2)) {
        getDBColumnDisplayInfo("presaleropcode").setReadonly(true);
        setItemValue(paramInt, "presaleropcode", "");
        setItemValue(paramInt, "presalername", "");
        setItemValue(paramInt, "presadeptname", "");
        setItemValue(paramInt, "presalerid", "");
        setItemValue(paramInt, "presadeptid", "");
        setItemValue(paramInt, "total", "");
        setItemValue(paramInt, "oldprerecid", "");
      } else if ("2".equals(paramString2)) {
        errorMessage("错误", "您只能选择预收款或者收欠款，不能选择现收类型！");
        setItemValue(paramInt, paramString1, "");
      } 
    } else if ("recexpmoney".equals(paramString1)) {
      String str1 = getItemValue(paramInt, "premoney");
      String str2 = getItemValue(paramInt, "recexpmoney");
      setItemValue(paramInt, "total", DecimalHelper.sub(str1, 
            str2, 2));
    } else if ("oldprerecid".equals(paramString1) && !"".equals(paramString2)) {
      String str;
      if ((str = getItemValue(paramInt, "fmid")) != null && !str.equals("")) {
        String str1 = "select fmrate from pub_formoney where fmid = " + 
          paramString2;
        RemotesqlHelper remotesqlHelper = new RemotesqlHelper();
        DBTableModel dBTableModel = new DBTableModel();
        try {
          dBTableModel = remotesqlHelper.doSelect(str1, 0, 1);
        } catch (Exception exception) {
          (str1 = null).printStackTrace();
        } 
        if (dBTableModel != null && !dBTableModel.equals("")) {
          str1 = dBTableModel.getItemValue(0, "fmrate");
          setItemValue(paramInt, "exchange", str1);
        } 
      } 
    } else if ("premoney".equals(paramString1)) {
      String str = getItemValue(paramInt, "recmethod");
      if ("3".equals(str)) {
        String str1 = "".equals(paramString2) ? "0" : paramString2;
        String str2 = getItemValue(paramInt, "recexpmoney");
        str2 = "".equals(str2) ? "0" : str2;
        setItemValue(paramInt, "total", DecimalHelper.sub(str1, 
              str2, 2));
      } 
    } else if ("notesno".equals(paramString1)) {
      if (paramString2 != null && !"".equals(paramString2)) {
        Pub_notes_hov pub_notes_hov = new Pub_notes_hov();
        String str1 = "notestype = 1 and usestatus = 1 and notesno like '" + paramString2 + "%'";
        pub_notes_hov.setOtherwheres(str1);
        DBTableModel dBTableModel;
        if ((dBTableModel = pub_notes_hov.showDialog((Frame)this.frame, "承兑票据管理")) == null)
          return; 
        String str2 = dBTableModel.getItemValue(0, "seqid");
        str1 = dBTableModel.getItemValue(0, "notesno");
        setItemValue(paramInt, "notesid", str2);
        setItemValue(paramInt, "notesno", str1);
        tableChanged();
      } 
    } else if ("total".equals(paramString1)) {
      String str1 = getItemValue(paramInt, "recmethod");
      String str2 = getItemValue(paramInt, "oldprerecid");
      if ("1".equals(str1) && str2 != null && !"".equals(str2))
        setItemValue(paramInt, "premoney", paramString2); 
    } 
    super.on_itemvaluechange(paramInt, paramString1, paramString2);
  }
  
  protected JPanel createSecondtoolbar() {
    JPanel jPanel = new JPanel();
    CToolbar cToolbar = new CToolbar();
    jPanel.setLayout(new BorderLayout());
    jPanel.add((Component)cToolbar);
    return jPanel = NpbusiDBHelper.createTButton(jPanel = NpbusiDBHelper.createTButton(jPanel = NpbusiDBHelper.createTButton(jPanel = NpbusiDBHelper.createTButton(jPanel = NpbusiDBHelper.createTButton(jPanel = NpbusiDBHelper.createTButton(jPanel = NpbusiDBHelper.createTButton(jPanel, "由结算单生成(G)", "由结算单生成", "由结算单生成", 71, (ActionListener)this.mdemodel), "自动生成(O)", "自动生成", "自动生成", 79, (ActionListener)this.mdemodel), "确定(C)", "确定", "确定", 67, (ActionListener)this.mdemodel), "回退确定(B)", "回退确定", "回退确定", 66, (ActionListener)this.mdemodel), "预收款作废(X)", "预收款作废", "预收款作废", 88, (ActionListener)this.mdemodel), "收款单作废(I)", "收款单作废", "收款单作废", 73, (ActionListener)this.mdemodel), "切换独立单元(A)", "切换独立单元", "切换独立单元", 65, (ActionListener)this.mdemodel);
  }
  
  protected String getEditablecolumns(int paramInt) {
    String str = getItemValue(paramInt, "usestatus");
    if (!"2".equals(str))
      return "nothing"; 
    int i;
    if ((i = this.mdemodel.getDetailModel().getDBtableModel().getRowCount()) > 0) {
      String str1 = getItemValue(paramInt, "recmethod");
      if ("3".equals(str1))
        return "credate,bankbillno,rectypeid,bankopcode,recexptype,recexpmoney,memo,notesno,draftdate,recmanopcode,presaleropcode"; 
      if ("1".equals(str1))
        return "credate,bankbillno,rectypeid,bankopcode,memo,notesno,draftdate,recmanopcode,presaleropcode"; 
    } 
    if (getRowCount() > 0 && paramInt < getRowCount() && i <= 0 && 
      "2".equals(str)) {
      String str1 = getItemValue(paramInt, "recmethod");
      if ("3".equals(str1))
        return "customopcode,credate,bankbillno,recmethod,rectypeid,bankopcode,recexptype,recexpmoney,presaleropcode,fmopcode,memo,agentopcode,notesno,draftdate,recmanopcode"; 
      if ("1".equals(str1))
        return "customopcode,credate,bankbillno,recmethod,rectypeid,oldprerecid,bankopcode,presaleropcode,total,fmopcode,memo,agentopcode,notesno,draftdate,recmanopcode"; 
    } 
    return super.getEditablecolumns(paramInt);
  }
  
  public boolean canInvokehov(String paramString) {
    if (paramString.equals("customopcode")) {
      String str1;
      if (!(str1 = getItemValue(getRow(), "oldprerecid")).equals("") && str1 != null) {
        infoMessage("提示", "您已经选择了原预收款单，不能更改客户！");
        return false;
      } 
    } 
    if (paramString.equals("fmopcode")) {
      String str1;
      if ((str1 = getItemValue(getRow(), "oldprerecid")) != null && !str1.equals("")) {
        infoMessage("提示", "您已经选择了原预收款单，不能更改外币！");
        return false;
      } 
    } 
    String str;
    if (paramString.equals("presaleropcode") && ((
      
      str = getItemValue(getRow(), "customid")) == null || str.equals(""))) {
      infoMessage("提示", "请先选择客户,才能选择业务员！");
      return false;
    } 
    return super.canInvokehov(paramString);
  }
  
  protected int on_beforemodify(int paramInt) {
    setFocus("credate");
    return super.on_beforemodify(paramInt);
  }
  
  public void on_doubleclick(int paramInt1, int paramInt2) {
    setFocus("credate");
    super.on_doubleclick(paramInt1, paramInt2);
  }
  
  public String getHovOtherWheres(int paramInt, String paramString) {
    String str1, str2 = ((Bms_sa_rec_mde)this.mdemodel).getEntryid();
    if (paramString.equals("presaleropcode")) {
      paramString = getItemValue(paramInt, "customid");
      if ((str2 = getItemValue(paramInt, "entryid")) == null || str2.equals("")) {
        errorMessage("提示", "没有独立单元");
        return "1=2";
      } 
      if (paramString == null || paramString.equals("")) {
        errorMessage("提示", "请先选择客户");
        return "1=2";
      } 
      return "customid = " + paramString + " and entryid=" + 
        
        str2;
    } 
    if (paramString.equals("oldprerecid")) {
      if ((paramString = getItemValue(paramInt, "customid")) == null || paramString.length() == 0) {
        infoMessage("提示！", "请先确定客户！");
        return null;
      } 
      if ((str1 = getItemValue(paramInt, "agentid")) == null || str1.equals(""))
        str1 = "-1"; 
      return "customid = " + 
        paramString + 
        " and entryid = " + (
        (Bms_sa_rec_mde)this.mdemodel).getEntryid() + 
        " and nvl(agentid,-1)=" + str1 + 
        " and not exists (select * from bms_sa_rec_doc a   where nvl(a.premoney,0)+nvl(a.recexpmoney,0)>=nvl(total,0) " + 
        " and bms_sa_rec_doc_hov_v.sarecid = a.sarecid )";
    } 
    if (paramString.equals("agentopcode")) {
      if ((paramString = getItemValue(str1, "customid")).equals("") || paramString == null) {
        infoMessage("提示！", "请选择客户！");
        return " 1>2";
      } 
      return " type=2 and companyid=" + paramString + " and (entryid is null or entryid=" + str2 + ")";
    } 
    if (paramString.equals("agentid"))
      return " type=2 and (entryid is null or entryid=" + str2 + ")"; 
    if (paramString.equals("presalerid"))
      return "entryid=" + str2; 
    return super.getHovOtherWheres(str1, paramString);
  }
  
  protected String getOtherWheres() {
    String str;
    if ((str = ((Bms_sa_rec_mde)this.mdemodel).getEntryid()) == null || str.length() == 0) {
      infoMessage("提示", "您当前登录的角色没有指定独立单元，不能操作！");
      return null;
    } 
    str = "entryid = " + str;
    return str = String.valueOf(str) + super.getOtherWheres();
  }
  
  public void setItemValue(int paramInt, String paramString1, String paramString2) {
    if (paramString1.equals("premoney"))
      on_itemvaluechange(paramInt, "premoney", paramString2); 
    super.setItemValue(paramInt, paramString1, paramString2);
  }
}
